; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNCTION_COMMAND_AUSWERTUNG:
	; ROM-COMMAND schon empfangen ?	
	LDS temp,(adr_OW_FUNCTION_COMMAND)
	tst temp
	brne FUNCTION_COMMAND_AUSWERTUNG_RUN
; ------------------------------------------------------------------------------
	; CLEAR							

	; ROM-COMMAND speichern			
	mov temp,OW_BYTE
	STS(adr_OW_FUNCTION_COMMAND),temp
; ------------------------------------------------------------------------------
FUNCTION_COMMAND_AUSWERTUNG_RUN:
	cpi temp,(OW_FUNCTION_CONVERT_T)				; CONWERT		
	brne PC+2
 	rjmp FUNCTION_CONVERT
	cpi temp,(OW_FUNCTION_RECALL_EE)				; RECALL		
	brne PC+2
 	rjmp FUNCTION_RECALL_EE
	cpi temp,(OW_FUNCTION_READ_SCRATCHPAD)			; READ_SCRATCHPAD
	brne PC+2
 	rjmp FUNCTION_MASTER_READ_SCRATCHPAD
	cpi temp,(OW_FUNCTION_READ_SCRATCHPAD_PRIVATE)	; READ_SCRATCHPAD-PRIVATE
	brne PC+2
 	rjmp FUNCTION_MASTER_READ_SCRATCHPAD
	cpi temp,(OW_FUNCTION_WRITE_SCRATCHPAD)			; WRITE_SCRATCHPAD
	brne PC+2
	rjmp FUNCTION_WRITE_SCRATCHPAD
	cpi temp,(OW_FUNCTION_WRITE_SCRATCHPAD_PRIVATE)	; WRITE_SCRATCHPAD-PRIVATE
	brne PC+2
	rjmp FUNCTION_WRITE_SCRATCHPAD
	; unbekanntes ROM COMMAND ==> SPERREN
	STS(adr_OW_ERROR_FUNCTION),temp				; speichern	
	cbi (LED_OW_ROT_PORT),(LED_OW_ROT_PIN_NR)	; ROT		
	rjmp STATUS_SPERREN_SETZEN					;  STATUS: gesperrt		
; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNCTION_CONVERT:
	cbi (LED_OW_GELB_PORT),(LED_OW_GELB_PIN_NR)		; GELB 	(OW)			
	STS(adr_OW_FREIGABE_MESSUNG),EINS				; MESSUNG_AKTIVIEREN	
	rjmp STATUS_SPERREN_SETZEN						;  STATUS: gesperrt		
; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNCTION_RECALL_EE:
	cbi (LED_OW_GELB_PORT),(LED_OW_GELB_PIN_NR)		; GELB 	(OW)			
	rjmp STATUS_SPERREN_SETZEN						;  STATUS: gesperrt		
; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNCTION_MASTER_READ_SCRATCHPAD:
	LDS temp,(adr_OW_BIT_NR)
	dec temp
	STS(adr_OW_BIT_NR),temp
	brne  FUNCTION_READ_SCRATCHPAD_w
; ------------------------------------------------------------------------------
	; neues BYTE laden							
	cbi (LED_OW_GELB_PORT),(LED_OW_GELB_PIN_NR)	; GELB 	(OW)		
	ldi temp,8
	STS(adr_OW_BIT_NR),temp

	LDS temp,(adr_OW_BYTE_ZAEHLER)				; BYTE-ZHLER		
	inc temp
	STS(adr_OW_BYTE_ZAEHLER),temp


	ldi ZL, LOW(adr_OW_SCRATCHPAD_BEREICH256-1)	; Z(SRAM)			
	ldi ZH,HIGH(adr_OW_SCRATCHPAD_BEREICH256-1)
	add ZL,temp									; Z + ZHLER		
	adc ZH,NULL
	LD OW_BYTE,Z								; neues BYTE laden	
; ------------------------------------------------------------------------------
FUNCTION_READ_SCRATCHPAD_w:
	LSR	OW_BYTE									; logisch rechts	
	rjmp STATUS_TX_SLOT_SETZEN_C				; inp: C			
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNCTION_WRITE_SCRATCHPAD:
	; ZHLER+1			
	LDS temp,(adr_OW_BYTE_ZAEHLER)
	inc temp
	STS (adr_OW_BYTE_ZAEHLER),temp
	; BERLAUF ?		
	cpi temp,0
	breq FUNCTION_WRITE_SCRATCHPAD_ERROR
	; INITIALISIERUNG ?	
	cpi temp,1
	brne FUNCTION_WRITE_SCRATCHPAD_RUN
	cbi (LED_OW_GELB_PORT),(LED_OW_GELB_PIN_NR)	; GELB 	(OW)
	ret
; ------------------------------------------------------------------------------
FUNCTION_WRITE_SCRATCHPAD_ERROR:
	cbi (LED_OW_ROT_PORT),LED_OW_ROT_PIN_NR		; ROT	
	rjmp STATUS_SPERREN_SETZEN					;  STATUS: gesperrt		
; ------------------------------------------------------------------------------
FUNCTION_WRITE_SCRATCHPAD_RUN:
	ldi ZL, LOW(adr_OW_SCRATCHPAD_BEREICH256-2)
	ldi ZH,HIGH(adr_OW_SCRATCHPAD_BEREICH256-2)
	add ZL,temp
	adc ZH,NULL
	ST Z,OW_BYTE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
