; ##############################################################################
; ##############################################################################
; ##############################################################################
; INITIALISIERUNG																
;																				
ONE_WIRE_INITIALISIERUNG:
	; PORT + PIN definieren				
	cbi (OW_DDR), (OW_PIN_NR)	; AUF EINGANG	
	cbi (OW_PORT),(OW_PIN_NR)	; PULL-UP aus	
	; 1-wire-STATUS	sperren !			
	rcall STATUS_SPERREN_SETZEN	;  STATUS: gesperrt		
	;  1-WIRE-ROM-ID					
	ldi temp1,ROM_ID_BYTE1
	ldi temp2,ROM_ID_BYTE2
	ldi temp3,ROM_ID_BYTE3
	ldi temp4,ROM_ID_BYTE4
	ldi temp5,ROM_ID_BYTE5
	ldi temp6,ROM_ID_BYTE6
	ldi temp7,ROM_ID_BYTE7
	ldi temp8,ROM_ID_BYTE8
	STS(adr_OW_ROM_ID_BEREICH8+0),temp1
	STS(adr_OW_ROM_ID_BEREICH8+1),temp2
	STS(adr_OW_ROM_ID_BEREICH8+2),temp3
	STS(adr_OW_ROM_ID_BEREICH8+3),temp4
	STS(adr_OW_ROM_ID_BEREICH8+4),temp5
	STS(adr_OW_ROM_ID_BEREICH8+5),temp6
	STS(adr_OW_ROM_ID_BEREICH8+6),temp7
	STS(adr_OW_ROM_ID_BEREICH8+7),temp8
	; SCRATCHPAD-C(BEISPIEL DS18s20) 0x00100CFFFF464B002E	
	;50 05 4B 46 7F FF 0C 10 1C

	ldi temp ,0x50
	ldi temp1,0x05
	ldi temp2,0x4B
	ldi temp3,0x46
	ldi temp4,0x7F
	ldi temp5,0xFF
	ldi temp6,0x0C
	ldi temp7,0x10
	ldi temp8,0x1C+1
	STS(adr_OW_SCRATCHPAD_BEREICH256+0),temp
	STS(adr_OW_SCRATCHPAD_BEREICH256+1),temp1
	STS(adr_OW_SCRATCHPAD_BEREICH256+2),temp2
	STS(adr_OW_SCRATCHPAD_BEREICH256+3),temp3
	STS(adr_OW_SCRATCHPAD_BEREICH256+4),temp4
	STS(adr_OW_SCRATCHPAD_BEREICH256+5),temp5
	STS(adr_OW_SCRATCHPAD_BEREICH256+6),temp6
	STS(adr_OW_SCRATCHPAD_BEREICH256+7),temp7
	STS(adr_OW_SCRATCHPAD_BEREICH256+8),temp8
	; 1-WIRE CRC Check				
	rcall ROM_CRC7
	; 1-WIRE CRC Check				
	rcall SCRATCHPAD_CRC8
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CRC Berechnung bernommen und abgendert von: http://s-huehn.de				
; CRC-Berechnung Application Note 27 von Dallas/Maxim							
;																				
; CRC-ROM																		
; INP: SRAM																		
;																				
; CRC Berechnung bernommen und abgendert von: http://s-huehn.de				
; CRC-Berechnung Application Note 27 von Dallas/Maxim							
;																				
; INP: SRAM(adr_ROM_CRC_BEREICH)												
; OUT: CARRY + R0(CRC-WERT)														
;																				
ROM_CRC7:
 	ldi ZL,low (adr_OW_ROM_ID_BEREICH8) 	; Z-Zeiger 					
    ldi ZH,high(adr_OW_ROM_ID_BEREICH8) 
    ldi     r19, 7                          ;7 Bytes berechnen			
    ldi     r20, 0x18                       ;Konstante fr Berechnung
    clr     r17                            	;CRC-Startwert = 0 setzen
ROM_CRC7_100: 
	LD      r18, Z+                         ;Byte aus Puffer holen
    mov     r21, r18                        ;Byte zwischenspeichern
    ldi     r16, 8                          ;8 Verschiebungen
ROM_CRC7_200: 
	eor     r18, r17                      	;CRC berechnen
    ror     r18                             ;Ergebnis in Carry schieben
    mov     r18, r17                      	;letzten CRC-Wert holen
    brcc    ROM_CRC7_300                    ;war Ergebnis = 0? ja -> weiter
    eor     r18, r20                        ;sonst CRC-Wert updaten
ROM_CRC7_300: 
	ror     r18                             ;neuen CRC-Wert positionieren
    mov     r17, r18          	            ;und speichern
    mov     r18, r21                        ;restliche Bits holen
    bst     r18, 0                          ;LSB sichern, nchste Bitposition
    ror     r18                             ;gesichertes Bit als MSB einsetzen
    bld     r18, 7                          ;(Ersatz fr RR-Befehl)
    mov     r21, r18                        ;und Wert zwischenspeichern
    dec     r16                             ;alle Verschiebungen erledigt?
    brne    ROM_CRC7_200               		;nein -> Schleife
    dec     r19                             ;alle Bytes bearbeitet?
    brne    ROM_CRC7_100              		 ;nein -> Schleife
;-------------------------------------------------------------------------------
	; Ergebnis in R17	
	LD r16,Z
	cp r16,r17
	brne ROM_CRC7_ERROR
	ret
;-------------------------------------------------------------------------------
; ERROR 																		
ROM_CRC7_ERROR:
	ST Z,R17
	ldi temp9,20
ROM_CRC7_ERROR_s:
	cbi (LED_OW_ROT_PORT),(LED_OW_ROT_PIN_NR)	; ROT	(OW)
	rcall WAIT_20ms
	sbi (LED_OW_ROT_PORT),(LED_OW_ROT_PIN_NR)	; ROT	(OW)
	rcall WAIT_20ms
	dec temp9
	brne ROM_CRC7_ERROR_s	
	rjmp ROM_CRC7
; ##############################################################################
; ##############################################################################
; ##############################################################################
SCRATCHPAD_CRC8:
 	ldi ZL,low (adr_OW_SCRATCHPAD_BEREICH256) ; Z-Zeiger 					
    ldi ZH,high(adr_OW_SCRATCHPAD_BEREICH256) 
    ldi     r19, 8                          ;7 Bytes berechnen			
    ldi     r20, 0x18                       ;Konstante fr Berechnung
    clr     r17                            	;CRC-Startwert = 0 setzen
SCRATCHPAD_CRC8_100: 
	LD      r18, Z+                         ;Byte aus Puffer holen
    mov     r21, r18                        ;Byte zwischenspeichern
    ldi     r16, 8                          ;8 Verschiebungen
SCRATCHPAD_CRC8_200: 
	eor     r18, r17                      	;CRC berechnen
    ror     r18                             ;Ergebnis in Carry schieben
    mov     r18, r17                      	;letzten CRC-Wert holen
    brcc    SCRATCHPAD_CRC8_300             ;war Ergebnis = 0? ja -> weiter
    eor     r18, r20                        ;sonst CRC-Wert updaten
SCRATCHPAD_CRC8_300: 
	ror     r18                             ;neuen CRC-Wert positionieren
    mov     r17, r18          	            ;und speichern
    mov     r18, r21                        ;restliche Bits holen
    bst     r18, 0                          ;LSB sichern, nchste Bitposition
    ror     r18                             ;gesichertes Bit als MSB einsetzen
    bld     r18, 7                          ;(Ersatz fr RR-Befehl)
    mov     r21, r18                        ;und Wert zwischenspeichern
    dec     r16                             ;alle Verschiebungen erledigt?
    brne    SCRATCHPAD_CRC8_200        		;nein -> Schleife		
    dec     r19                             ;alle Bytes bearbeitet?	
    brne    SCRATCHPAD_CRC8_100    		 	;nein -> Schleife		
;-------------------------------------------------------------------------------
	; Ergebnis in R17	
	ST Z,R17			; vorsichtshalber nochmal speichern
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
STATUS_RX_BEREIT_SETZEN:
	; SPERREN						
	ldi temp,(OW_STATUS_RX_BEREIT)
	mov STATUS,temp	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
STATUS_SPERREN_SETZEN:
	; SPERREN						
	ldi temp,(OW_STATUS_GESPERRT)
	mov STATUS,temp	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
STATUS_TX_0SLOT_SETZEN:
	; STATUS		
	ldi temp,(OW_STATUS_TX_0SLOT)
	mov STATUS,temp	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
STATUS_TX_1SLOT_SETZEN:
	; STATUS		
	ldi temp,(OW_STATUS_TX_1SLOT)
	mov STATUS,temp	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CARRY bleibt erhalen															
STATUS_TX_SLOT_SETZEN_C:
	brcc STATUS_TX_SLOT_SETZEN_C_CC
	ldi temp,(OW_STATUS_TX_1SLOT)
	mov STATUS,temp	
	ret
STATUS_TX_SLOT_SETZEN_C_CC:
	ldi temp,(OW_STATUS_TX_0SLOT)
	mov STATUS,temp	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

