; ##############################################################################
; ##############################################################################
; ##############################################################################
; sehr zeitkritisch ist das Schreiben eines 0-SLOT !							
;																				
; IMPULSLNGE MASTER: 6s														
;																				
; INP/OUT: SRAM(OW_STATUS)														
EXT_INT0:
	; SLAVE-TX-0SLOT ?			
	sbrc STATUS,1
	sbi (OW_DDR),(OW_PIN_NR)				; sofort AUF AUSGANG !				
;-------------------------------------------------------------------------------
	in	SREG_KOPIE  ,SREG					; SREG sichern						
	mov TEMP_KOPIE  ,temp					; TEMP sichern						
	MOVW ZL_KOPIE,ZL						; Z sichern (Copy Register Word)	
;-------------------------------------------------------------------------------
; STATUS abfragen																
	; SLAVE-TX-0SLOT ?			
	sbrc STATUS,1
	rjmp INTERRUPT_MODUS_SLAVE_WRITE_0SLOT	; SLAVE-TX-0SLOT		
	; SLAVE-TX-1SLOT ?			
	sbrc STATUS,2
	rjmp INTERRUPT_MODUS_SLAVE_WRITE_1SLOT	; SLAVE-TX-1SLOT		
	; SLAVE-RX					
	sbrc STATUS,0
	rjmp INTERRUPT_MODUS_SLAVE_READ			; SLAVE-RX				
	; gesperrt, warten auf RESET-PRESENCE !	
	rjmp INTERRUPT_RESET_PRESENCE_CHECK
;-------------------------------------------------------------------------------
; SLAVE-WRITE 0-SLOT (WARTEZEIT nutzen fr BERECHNUNG)							
INTERRUPT_MODUS_SLAVE_WRITE_0SLOT:
	; FUNCTION-COMMAND abgearbeitet ? ; Reihenfolge nicht tauschen !!!		
	LDS temp,(adr_OW_FUNCTION_COMMAND_GESPERRT)
	SBRS temp,0
	rcall FUNCTION_COMMAND_AUSWERTUNG
	; ROM-COMMAND abgearbeitet ?	; Reihenfolge nicht tauschen !!!		
	LDS temp,(adr_OW_ROM_COMMAND_GESPERRT)
	SBRS temp,0
	rcall ROM_COMMAND_AUSWERTUNG
	; PAUSE ca.25s (0-SLOT) MASTER SAMPLES nach ca 9s		
	rcall WAIT_5us
	rcall WAIT_5us
	rcall WAIT_5us
	rcall WAIT_5us
	rcall WAIT_5us
	cbi (OW_DDR), (OW_PIN_NR)		; AUF EINGANG	
	rjmp INTERRUPT_RESET_PRESENCE_CHECK
;-------------------------------------------------------------------------------
; SLAVE-WRITE 1-SLOT															
INTERRUPT_MODUS_SLAVE_WRITE_1SLOT:
	rjmp INTERRUPT_AUSWERTUNG
;-------------------------------------------------------------------------------
; READ 0/1 SLOT																	
INTERRUPT_MODUS_SLAVE_READ:
	; ca. 9s PAUSE				
	rcall WAIT_5us
	rcall WAIT_5us
	; SAMPLES !!! (PIN abfragen)	
	CLC								; Carry clear			
	sbic (OW_PIN),(OW_PIN_NR)		; springe, wenn PIN LOW	
	SEC								; CARRY set				
	ROR OW_BYTE						; 1xrechts ber CARRY	
	; BIT-ZHLER-1					
	dec OW_BIT_NR
	brne INTERRUPT_RESET_PRESENCE_CHECK
	; BIT-ZHLER=8					
	ldi temp,8
	mov OW_BIT_NR,temp
;-------------------------------------------------------------------------------
INTERRUPT_AUSWERTUNG:
	; FUNCTION-COMMAND abgearbeitet ? ; Reihenfolge nicht tauschen !!!		
	LDS temp,(adr_OW_FUNCTION_COMMAND_GESPERRT)
	SBRS temp,0
	rcall FUNCTION_COMMAND_AUSWERTUNG
	; ROM-COMMAND abgearbeitet ?	; Reihenfolge nicht tauschen !!!		
	LDS temp,(adr_OW_ROM_COMMAND_GESPERRT)
	SBRS temp,0
	rcall ROM_COMMAND_AUSWERTUNG
;-------------------------------------------------------------------------------
; RESET and PRESENCE ?															
INTERRUPT_RESET_PRESENCE_CHECK:
	clr ZL
	clr ZH
INTERRUPT_RESET_PRESENCE_CHECK_SCHLEIFE:
	; springe, wenn PIN low				
	sbic (OW_PIN),(OW_PIN_NR)
	rjmp INTERRUPT_RESET_PRESENCE_CHECK_AUSWERTUNG
	adiw ZL,1	; ZHLER+1				
	brcc INTERRUPT_RESET_PRESENCE_CHECK_SCHLEIFE	; SCHLEIFE	
	; BERLAUF !						
	sbiw ZL,1	; -1
	cbi (LED_OW_ROT_PORT),LED_OW_ROT_PIN_NR			; ROT		
	rjmp INTERRUPT_RESET_PRESENCE_CHECK_SCHLEIFE
;-------------------------------------------------------------------------------
INTERRUPT_RESET_PRESENCE_CHECK_AUSWERTUNG:
	; LOW-IMPULSLNGE auswerten				
	tst ZH			; vergleich (HIGH)		
	brne INTERRUPT_RESET_PRESENCE_IMPULS
	cpi ZL,100		; vergleich (LOW)		
	brlo INTERRUPT_FERTIG
;-------------------------------------------------------------------------------
; RESET and PRESENCE !															
INTERRUPT_RESET_PRESENCE_IMPULS:
	; ZHLER speichern (Wartungszwecke)			
	STS(adr_OW_ZAEHLER_RESET_PRESENCE_L),ZL	
	STS(adr_OW_ZAEHLER_RESET_PRESENCE_H),ZH	
	; CLEAR										
	ldi temp,8
	mov OW_BIT_NR,temp							; 8 !			
	clr OW_BYTE

	ldi temp,(OW_STATUS_RX_BEREIT)				; STATUS auf RX	
	mov STATUS,temp	

	STS(adr_OW_ROM_MATCH_ZAEHLER),NULL

	STS(adr_OW_ROM_SEARCH_ZAEHLER_AB),VOLL		; !!!			

	STS(adr_OW_BYTE_ZAEHLER),NULL

	STS(adr_OW_ROM_COMMAND_GESPERRT),NULL
	STS(adr_OW_FUNCTION_COMMAND_GESPERRT),EINS 	; !!!			

	STS(adr_OW_ROM_COMMAND),NULL
	STS(adr_OW_FUNCTION_COMMAND),NULL

	sbi (LED_OW_GRUEN_PORT),LED_OW_GRUEN_PIN_NR	; GRN							
	sbi (LED_OW_GELB_PORT),LED_OW_GELB_PIN_NR	; GELB 							
	sbi (LED_OW_ROT_PORT),LED_OW_ROT_PIN_NR		; ROT							
;-------------------------------------------------------------------------------
	; kurze Pause, SLAVE darf nicht zu schnell antworten
	rcall WAIT_5us
	rcall WAIT_5us
	rcall WAIT_5us
	rcall WAIT_5us
	rcall WAIT_5us
	rcall WAIT_5us	
	rcall WAIT_5us
;-------------------------------------------------------------------------------
	sbi (OW_DDR), (OW_PIN_NR)					; AUF AUSGANG			
	rcall WAIT_50us
	rcall WAIT_50us
	cbi (OW_DDR), (OW_PIN_NR)					; AUF EINGANG			
;-------------------------------------------------------------------------------
; REGISTER wieder herstellen													
INTERRUPT_FERTIG:
	OUT	SREG ,SREG_KOPIE		; SREG wieder herstellen							
	mov temp ,temp_KOPIE		; temp wieder herstellen							
	MOVW ZL,ZL_KOPIE 			; Copy Register Word								
	out GIFR,VOLL				; eventuelle Pegelwechsel ignorieren				
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
