; ##############################################################################
; ##############################################################################
; ##############################################################################
HYT939_INITIALISIERUNG:
; TWI HYT939 (%) 								
.equ HYT939_ADRESSE							= 40		; 40			
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
HYT939_MESSUNG:
	; ERROR Werte								
	ldi temp,99	; 99%	
	STS(adr_HYT939_RH),temp					
	ldi temp,98	; 98C	
	STS(adr_HYT939_TEMPERATUR_SIGNIERT),temp
	; MR (Measurement Requests)					
	; Die Messung dauert ca. 50ms				
	ldi temp1,(HYT939_ADRESSE)					; ADRESSE			
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1	; START-TRANSMITTER	
	rcall TWI_STOP								; STOP				
	rcall wait_100ms
	; ERRROR ?									
	tst  R0 ;TWI_FEHLER_CODE
	brne HYT939_MESSUNG_ERROR
HYT939_MESSUNG_s:
	; DF (Data Fetch)							
	ldi temp1,(HYT939_ADRESSE)						; ADRESSE			
	rcall TWI_MASTER_RECEIVER_START_TEMP1			; START-RECEIVER	

	rcall TWI_MASTER_RECEIVER_BYTE_TEMP1			; BYTE read			
	STS(adr_HYT939_DATA_MSB),temp1 					; %	(HIGH)			

	rcall TWI_MASTER_RECEIVER_BYTE_TEMP1			; BYTE read			
	STS(adr_HYT939_DATA_LSB),temp1 					; %	(LOW)			

	rcall TWI_MASTER_RECEIVER_BYTE_TEMP1			; BYTE read			
	STS(adr_HYT939_TEMPERATUR_DATA_MSB),temp1 		; Temperatur (HIGH)	

	rcall TWI_MASTER_RECEIVER_LAST_BYTE_TEMP1		; LAST BYTE read	
	STS(adr_HYT939_TEMPERATUR_DATA_LSB),temp1 		; Temperatur (LOW)	

	rcall TWI_STOP									; STOP				
	tst  R0 										; ERRROR ?			
	brne HYT939_MESSUNG_ERROR
;-------------------------------------------------------------------------------
	; Bit15: CMode Bit / Bit14:Stale Bit abfragen
	LDS temp,(adr_HYT939_DATA_MSB)
	andi temp,0b11000000
	tst temp
	breq HYT939_MESSUNG_w
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)		; ROT	
	rjmp HYT939_MESSUNG_s
;-------------------------------------------------------------------------------
HYT939_MESSUNG_w:
	; Temperatur-DATA 2 x rechts				
	LDS temp1,(adr_HYT939_TEMPERATUR_DATA_LSB)
	LDS temp2,(adr_HYT939_TEMPERATUR_DATA_MSB)
	LSR temp2
	ROR temp1
	LSR temp2
	ROR temp1
	STS(adr_HYT939_TEMPERATUR_DATA_LSB),temp1
	STS(adr_HYT939_TEMPERATUR_DATA_MSB),temp2
	; BERECHNUNG					
	rjmp HYT939_BERECHNUNG
;-------------------------------------------------------------------------------
HYT939_MESSUNG_ERROR:
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)		; ROT	
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
HYT939_BERECHNUNG:
	; rF [%] = 100 * rFraw / 2^14													
	LDS temp1,(adr_HYT939_DATA_LSB)
	LDS temp2,(adr_HYT939_DATA_MSB)
	; ldi temp1,LOW (7300); TESTZAHL 7300==> 0x2D (45%)						
	; ldi temp2,HIGH(7300)
	rcall HYT939_MULTIPLIKATION16_MAL_100_32 	; mal 100						
	rcall HYT939_DIVISION32_DURCH_HOCH_14		; durch 2^14		
	; rF>100 ?						
	cpi temp1,100+1
	brsh HYT939_BERECHNUNG_ERROR
	STS(adr_HYT939_RH),temp1					; Ergebnis			
;-------------------------------------------------------------------------------
	;T [C] = 165 / 2^14 * Traw - 40
	LDS temp1,(adr_HYT939_TEMPERATUR_DATA_LSB)
	LDS temp2,(adr_HYT939_TEMPERATUR_DATA_MSB)
	; ldi temp1,LOW (6000) ; TESTZAHL 6000==> 0x14 (20%)						
	; ldi temp2,HIGH(6000)
	rcall HYT939_MULTIPLIKATION16_MAL_165_32 	; mal 165						
	rcall HYT939_DIVISION32_DURCH_HOCH_14		; durch 2^14		
	ldi temp3, LOW(40)
	ldi temp4,HIGH(40)
	sub temp1,temp3								; Subtraktion		
	sbc temp2,temp4
	; T>100 ?						
	cpi temp1,100+1
	brsh HYT939_BERECHNUNG_ERROR
	STS(adr_HYT939_TEMPERATUR_SIGNIERT),temp1	; Ergebnis			
	ret
;-------------------------------------------------------------------------------
HYT939_BERECHNUNG_ERROR:
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT	
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
HYT939_MULTIPLIKATION16_MAL_100_32:
	; 99 mal addieren	
	ldi temp9,(100-1)
	mov R0,TEMP1
	mov R1,TEMP2
	clr temp3
	clr temp4
HYT939_MULTIPLIKATION16_MAL_100_32_s:
	add temp1,R0
	adc temp2,R1
	adc temp3,NULL
	adc temp4,NULL
	dec temp9
	brne HYT939_MULTIPLIKATION16_MAL_100_32_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
HYT939_MULTIPLIKATION16_MAL_165_32:
	; 164 mal addieren	
	ldi temp9,(165-1)
	mov R0,TEMP1
	mov R1,TEMP2
	clr temp3
	clr temp4
HYT939_MULTIPLIKATION16_MAL_165_32_s:
	add temp1,R0
	adc temp2,R1
	adc temp3,NULL
	adc temp4,NULL
	dec temp9
	brne HYT939_MULTIPLIKATION16_MAL_165_32_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
HYT939_DIVISION32_DURCH_HOCH_14:
	ldi temp9,14
HYT939_DIVISION32_2_HOCH_14_s:
	LSR temp4
	ROR temp3
	ROR temp2
	ROR temp1
	dec temp9
	brne HYT939_DIVISION32_2_HOCH_14_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################


