; ##############################################################################
; ##############################################################################
; ##############################################################################
TWI_DISPLAY_INITIALISIERUNG:
; ADRESSE-DISPLAY								
.equ ADRESSE_SLAVES_DISPLAY		= 32
; externes DISPLAY								
.equ DISP_D4					= 0
.equ DISP_D5					= 1
.equ DISP_D6					= 2
.equ DISP_D7					= 3
.equ DISP_RS					= 4
.equ DISP_RW					= 5
.equ DISP_E						= 6
.equ DISP_LED					= 7
;-------------------------------------------------------------------------------
	; PORT auf HIGH					
	ldi temp1,(ADRESSE_SLAVES_DISPLAY)		; ADRESSE laden		
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1
	ldi temp1, (1<<DISP_LED)|(1<<DISP_E)|(1<<DISP_RW)|(1<<DISP_RS)|(1<<DISP_D7)|(1<<DISP_D6)|(1<<DISP_D5)|(1<<DISP_D4)	; 1
	rcall TWI_MASTER_TRANSMITTER_BYTE_TEMP1
	rcall TWI_STOP
	tst R0
	breq TWI_DISPLAY_INITIALISIERUNG_RUN
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	rcall WAIT_1s
	rcall WAIT_1s
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	ret
;-------------------------------------------------------------------------------
TWI_DISPLAY_INITIALISIERUNG_RUN:
	rcall EXT_DISPLAY_INI
	rcall EXT_DISPLAY_BEGRUESSUNG
	rcall WAIT_1s
	rcall EXT_DISPLAY_CLEAR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; BIT-0: D4																		
; BIT-1: D5																		
; BIT-2: D6																		
; BIT-3: D7																		
; BIT-4: RS																		
; BIT-5: RW (0=WRITE)															
; BIT-6: ENABLE																	
; BIT-7: LIGHT (0=ON 1=OFF)														
EXT_DISPLAY_INI:
	; PORT auf HIGH					
	ldi temp1,(ADRESSE_SLAVES_DISPLAY)		; ADRESSE laden		
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1
	ldi temp1, (1<<DISP_LED)|(1<<DISP_E)|(1<<DISP_RW)|(1<<DISP_RS)|(1<<DISP_D7)|(1<<DISP_D6)|(1<<DISP_D5)|(1<<DISP_D4)	; 1
	rcall TWI_MASTER_TRANSMITTER_BYTE_TEMP1
  	; x03 muss 3mal hintereinander gesendet werden zur Initialisierung			
	ldi temp1,(ADRESSE_SLAVES_DISPLAY)		; ADRESSE laden		
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1
	ldi temp1, (0<<DISP_LED)|(1<<DISP_E)|(0<<DISP_RW)|(0<<DISP_RS)|(0<<DISP_D7)|(0<<DISP_D6)|(1<<DISP_D5)|(1<<DISP_D4)	; E=1 RS=0
	rcall TWI_MASTER_TRANSMITTER_BYTE_TEMP1
	rcall EXT_DISPLAY_ENABLE_TEMP1
	rcall WAIT_20ms
	;																			
	ldi temp1,(ADRESSE_SLAVES_DISPLAY)		; ADRESSE laden		
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1
	ldi temp1, (0<<DISP_LED)|(1<<DISP_E)|(0<<DISP_RW)|(0<<DISP_RS)|(0<<DISP_D7)|(0<<DISP_D6)|(1<<DISP_D5)|(1<<DISP_D4)	; E=1 RS=0
	rcall TWI_MASTER_TRANSMITTER_BYTE_TEMP1
	rcall EXT_DISPLAY_ENABLE_TEMP1
	rcall WAIT_20ms
	;																			
	ldi temp1,(ADRESSE_SLAVES_DISPLAY)		; ADRESSE laden		
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1
	ldi temp1, (0<<DISP_LED)|(1<<DISP_E)|(0<<DISP_RW)|(0<<DISP_RS)|(0<<DISP_D7)|(0<<DISP_D6)|(1<<DISP_D5)|(1<<DISP_D4)	; E=1 RS=0
	rcall TWI_MASTER_TRANSMITTER_BYTE_TEMP1
	rcall EXT_DISPLAY_ENABLE_TEMP1
	rcall WAIT_20ms
	;																			
    ldi temp1, 0b00000010        ;4bit-Modus einstellen			
	rcall EXT_DISPLAY_COMMAND_TEMP1
	rcall WAIT_20ms

	ldi temp1, 0b00101100        ; Function Set					
	rcall EXT_DISPLAY_COMMAND_TEMP1
	rcall WAIT_20ms

    ldi temp1, 0b00001111        ; DISPLAY ein / CURSOR blinken	
	rcall EXT_DISPLAY_COMMAND_TEMP1
	rcall WAIT_20ms

    ldi temp1, 0b00000110        ; Cursor Auto-Increment		
	rcall EXT_DISPLAY_COMMAND_TEMP1
	rcall WAIT_20ms

   	ldi temp1, 0b00000001
	rcall EXT_DISPLAY_COMMAND_TEMP1; CLEAR
	rcall WAIT_20ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; RS-BIT=0																		
EXT_DISPLAY_COMMAND_TEMP1:
	push temp1								; Sicherungskopie	
	ldi temp1,(ADRESSE_SLAVES_DISPLAY)		; ADRESSE laden		
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1
	pop  temp1								; wieder herstellen	
;-------------------------------------------------------------------------------
	push temp1	; Sicherungskopie	
	; HIGH NIBBLE senden			
	SWAP temp1											; NIBBLES Tausch	
	andi temp1,0b00001111								; BITMUSTER			
	ori temp1,(1<<DISP_E)|(0<<DISP_RS)					; E=1 RS=0			
	rcall TWI_MASTER_TRANSMITTER_BYTE_TEMP1				; DATA				
	rcall EXT_DISPLAY_ENABLE_TEMP1						; Enable			
	; LOW NIBBLE senden			
	pop temp1											; wieder herstellen	
	andi temp1,0b00001111								; BITMUSTER			
	ori temp1,(1<<DISP_E)|(0<<DISP_RS)					; E=1 RS=0			
	rcall TWI_MASTER_TRANSMITTER_BYTE_TEMP1				; DATA				
	rjmp EXT_DISPLAY_ENABLE_TEMP1						; Enable			
; ##############################################################################
; ##############################################################################
; ##############################################################################
; RS-BIT=1																		
EXT_DISPLAY_DATA_TEMP1:
	push temp1								; Sicherungskopie	
	ldi temp1,(ADRESSE_SLAVES_DISPLAY)		; ADRESSE laden		
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1
	pop  temp1								; wieder herstellen	
;-------------------------------------------------------------------------------
	push temp1											; Sicherungskopie	
	; HIGH NIBBLE senden			
	SWAP temp1											; NIBBLES Tausch	
	andi temp1,0b00001111								; BITMUSTER			
	ori temp1,(1<<DISP_E)|(1<<DISP_RS)					; E=1 RS=1			
	rcall TWI_MASTER_TRANSMITTER_BYTE_TEMP1				; DATA				
	rcall EXT_DISPLAY_ENABLE_TEMP1						; Enable			
	; LOW NIBBLE senden			
	pop temp1											; wieder herstellen	
	andi temp1,0b00001111								; BITMUSTER			
	ori temp1,(1<<DISP_E)|(1<<DISP_RS)					; E=1 RS=1			
	rcall TWI_MASTER_TRANSMITTER_BYTE_TEMP1				; DATA				
	rjmp EXT_DISPLAY_ENABLE_TEMP1						; Enable			
; ##############################################################################
; ##############################################################################
; ##############################################################################
; RW-BIT immer "0"																
; E-BIT=0																		
EXT_DISPLAY_ENABLE_TEMP1:
	andi temp1,(1<<DISP_LED)|(0<<DISP_E)|(0<<DISP_RW)|(1<<DISP_RS)|(1<<DISP_D7)|(1<<DISP_D6)|(1<<DISP_D5)|(1<<DISP_D4)	; ENABLE
	rcall TWI_MASTER_TRANSMITTER_BYTE_TEMP1
	rcall WAIT_1ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Display lschen														  		
EXT_DISPLAY_CLEAR:
   	ldi temp1, 0b00000001
    rcall EXT_DISPLAY_COMMAND_TEMP1
	rjmp EXT_DISPLAY_ZEILE1
; ##############################################################################
; ##############################################################################
; ##############################################################################
; KURSOR GO-HOME														  		
EXT_DISPLAY_ZEILE1:
 	ldi temp1, 0b00000010
	rjmp EXT_DISPLAY_COMMAND_TEMP1
; ##############################################################################
; ##############################################################################
; ##############################################################################
; KURSOR Sprung in ZEILE2												  		
EXT_DISPLAY_ZEILE2:
 	ldi temp1, 0b11000000 
	rjmp EXT_DISPLAY_COMMAND_TEMP1
; ##############################################################################
; ##############################################################################
; ##############################################################################
; KURSOR Sprung in ZEILE3														
EXT_DISPLAY_ZEILE3:
	;ldi temp, 0b10010100  	; LCD 4x20	
	ldi temp1, 0b10010000 	; LCD 4x16	
	rjmp EXT_DISPLAY_COMMAND_TEMP1
; ##############################################################################
; ##############################################################################
; ##############################################################################
; KURSOR Sprung in ZEILE4												  		
EXT_DISPLAY_ZEILE4:
	;ldi temp, 0b11010100	; LCD 4x20	
	ldi temp1, 0b11010000 	; LCD 4x16	
	rjmp EXT_DISPLAY_COMMAND_TEMP1
; ##############################################################################
; ##############################################################################
; ##############################################################################
EXT_DISPLAY_ANZEIGE_TEXT_Z:
	LPM temp1, Z+   						; aus Tabelle laden und Z+1	
	tst temp1  			
	breq EXT_DISPLAY_ANZEIGE_TEXT_Z_FERTIG 	; Sprung	
	rcall EXT_DISPLAY_DATA_TEMP1			; Anzeige	
	rjmp EXT_DISPLAY_ANZEIGE_TEXT_Z
EXT_DISPLAY_ANZEIGE_TEXT_Z_FERTIG:
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_SPACE:
	ldi temp1, ' '		; SPACE
	rjmp LCD_ANZEIGE_TEMP1
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_ANZEIGE_TEMP1:
	rjmp EXT_DISPLAY_DATA_TEMP1
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: temp1																
; OUT: (z.B."FF") 															
;																			
LCD_ANZEIGE_HEX_TEMP1:
	tst temp1
	brne LCD_ANZEIGE_HEX_TEMP1_RUN
	ldi temp1, '-'		; 
	rcall LCD_ANZEIGE_TEMP1
	ldi temp1, '-'		; 
	rcall LCD_ANZEIGE_TEMP1
	ret
;-------------------------------------------------------------------------------
LCD_ANZEIGE_HEX_TEMP1_RUN:
	; SICHERUNGSKOPIE						
	push temp
	push temp1
	; oberes NIBBLE bearbeiten				
	push temp1	
	swap temp1						; NIBBLES tausch	
	rcall ANZEIGE_HEX_UMWANDLUNG	; INP/OUT: temp1	
	rcall EXT_DISPLAY_DATA_TEMP1
	; unteres NIBBLE bearbeiten				
	pop temp1
	rcall ANZEIGE_HEX_UMWANDLUNG	; INP/OUT: temp1	
	rcall EXT_DISPLAY_DATA_TEMP1
	; SICHERUNGSKOPIE wieder herstellen		
	pop temp1
	pop temp
	ret
;-------------------------------------------------------------------------------
ANZEIGE_HEX_UMWANDLUNG:
	; BITMUSTER	
	andi temp1,0b00001111
	; vergleich	
	cpi temp1,10
	brsh ANZEIGE_HEX_UMWANDLUNG_A_F
ANZEIGE_HEX_UMWANDLUNG_0_9:
	subi temp1,-48
	ret
ANZEIGE_HEX_UMWANDLUNG_A_F:
	subi temp1,-48-7
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; einen TEXT bertragen															
EXT_DISPLAY_BEGRUESSUNG:
	rcall EXT_DISPLAY_CLEAR
	rcall EXT_DISPLAY_ZEILE1
	ldi ZH, high(TEXT_BEGRUESSUNG_1*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_1*2)
	rcall EXT_DISPLAY_ANZEIGE_TEXT_Z
	rcall EXT_DISPLAY_ZEILE2
	ldi ZH, high(TEXT_BEGRUESSUNG_2*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_2*2)
	rcall EXT_DISPLAY_ANZEIGE_TEXT_Z
	rcall EXT_DISPLAY_ZEILE3
	ldi ZH, high(TEXT_BEGRUESSUNG_3*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_3*2)
	rcall EXT_DISPLAY_ANZEIGE_TEXT_Z
	rcall EXT_DISPLAY_ZEILE4
	ldi ZH, high(TEXT_BEGRUESSUNG_4*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_4*2)
	rcall EXT_DISPLAY_ANZEIGE_TEXT_Z
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
EXT_DISPLAY_HAUPTMENUE:
	ldi temp1,(ADRESSE_SLAVES_DISPLAY)		; ADRESSE laden		
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1
	tst R0
	breq EXT_DISPLAY_HAUPTMENUE_RUN
	ret
;-------------------------------------------------------------------------------
EXT_DISPLAY_HAUPTMENUE_RUN:
	; ZEILE-1					
	rcall EXT_DISPLAY_ZEILE1
	LDS temp1,(adr_OW_ROM_ID_BEREICH8+0)
	rcall LCD_ANZEIGE_HEX_TEMP1_RUN	
	LDS temp1,(adr_OW_ROM_ID_BEREICH8+1)
	rcall LCD_ANZEIGE_HEX_TEMP1_RUN	
	LDS temp1,(adr_OW_ROM_ID_BEREICH8+2)
	rcall LCD_ANZEIGE_HEX_TEMP1_RUN	
	LDS temp1,(adr_OW_ROM_ID_BEREICH8+3)
	rcall LCD_ANZEIGE_HEX_TEMP1_RUN	
	LDS temp1,(adr_OW_ROM_ID_BEREICH8+4)
	rcall LCD_ANZEIGE_HEX_TEMP1_RUN	
	LDS temp1,(adr_OW_ROM_ID_BEREICH8+5)
	rcall LCD_ANZEIGE_HEX_TEMP1_RUN	
	LDS temp1,(adr_OW_ROM_ID_BEREICH8+6)
	rcall LCD_ANZEIGE_HEX_TEMP1_RUN	
	LDS temp1,(adr_OW_ROM_ID_BEREICH8+7)
	rcall LCD_ANZEIGE_HEX_TEMP1_RUN	
	; ZEILE-2					
	rcall EXT_DISPLAY_ZEILE2
	ldi temp1,'R'
	rcall LCD_ANZEIGE_TEMP1
	ldi temp1,'P'
	rcall LCD_ANZEIGE_TEMP1
	ldi temp1,':'
	rcall LCD_ANZEIGE_TEMP1
	LDS temp1,(adr_OW_ZAEHLER_RESET_PRESENCE_H)
	rcall LCD_ANZEIGE_HEX_TEMP1	
	LDS temp1,(adr_OW_ZAEHLER_RESET_PRESENCE_L)
	rcall LCD_ANZEIGE_HEX_TEMP1	
	rcall LCD_SPACE

	ldi temp1,'S'
	rcall LCD_ANZEIGE_TEMP1
	ldi temp1,':'
	rcall LCD_ANZEIGE_TEMP1
	mov temp1,STATUS
	rcall LCD_ANZEIGE_HEX_TEMP1	

	rcall LCD_SPACE
	ldi temp1,'R'
	rcall LCD_ANZEIGE_TEMP1
	mov temp1,OW_BYTE
	rcall LCD_ANZEIGE_HEX_TEMP1	
	; ZEILE-3					
	rcall EXT_DISPLAY_ZEILE3
	ldi temp1,'R'				; RC: 
	rcall LCD_ANZEIGE_TEMP1
	ldi temp1,':'
	rcall LCD_ANZEIGE_TEMP1
	LDS temp1,(adr_OW_ROM_COMMAND)
	rcall LCD_ANZEIGE_HEX_TEMP1	
	rcall LCD_SPACE

	ldi temp1,'F'				; FC: 
	rcall LCD_ANZEIGE_TEMP1
	ldi temp1,':'
	rcall LCD_ANZEIGE_TEMP1
	LDS temp1,(adr_OW_FUNCTION_COMMAND)
	rcall LCD_ANZEIGE_HEX_TEMP1	
	rcall LCD_SPACE

	LDS temp1,(adr_OW_ERROR_COMMAND)	; 
	rcall LCD_ANZEIGE_HEX_TEMP1	
	rcall LCD_SPACE	

	LDS temp1,(adr_OW_ERROR_FUNCTION)	; 
	rcall LCD_ANZEIGE_HEX_TEMP1	

	; ZEILE-4					
	rcall EXT_DISPLAY_ZEILE4
;	rcall EXT_DISPLAY_ANZEIGE_SCRATCHPAD_KURZ
	rcall EXT_DISPLAY_ANZEIGE_WERTE_KURZ
	; PAUSE						
	rcall TWI_STOP
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
EXT_DISPLAY_ANZEIGE_SCRATCHPAD_KURZ:
	LDS temp1,(adr_OW_SCRATCHPAD_BEREICH256+0)	; 
	rcall LCD_ANZEIGE_HEX_TEMP1	
	LDS temp1,(adr_OW_SCRATCHPAD_BEREICH256+1)	; 
	rcall LCD_ANZEIGE_HEX_TEMP1	
	LDS temp1,(adr_OW_SCRATCHPAD_BEREICH256+2)	; 
	rcall LCD_ANZEIGE_HEX_TEMP1	
	LDS temp1,(adr_OW_SCRATCHPAD_BEREICH256+3)	; 
	rcall LCD_ANZEIGE_HEX_TEMP1	
	LDS temp1,(adr_OW_SCRATCHPAD_BEREICH256+4)	; 
	rcall LCD_ANZEIGE_HEX_TEMP1	
	LDS temp1,(adr_OW_SCRATCHPAD_BEREICH256+5)	; 
	rcall LCD_ANZEIGE_HEX_TEMP1	
	LDS temp1,(adr_OW_SCRATCHPAD_BEREICH256+6)	; 
	rcall LCD_ANZEIGE_HEX_TEMP1	
	LDS temp1,(adr_OW_SCRATCHPAD_BEREICH256+7)	; 
	rcall LCD_ANZEIGE_HEX_TEMP1	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
EXT_DISPLAY_ANZEIGE_WERTE_KURZ:
	ldi temp1,'%'
	rcall LCD_ANZEIGE_TEMP1
	LDS temp1,(adr_HYT939_RH)				; %
	rcall LCD_ANZEIGE_HEX_TEMP1	
	rcall LCD_SPACE

	LDS temp1,(adr_HYT939_TEMPERATUR_SIGNIERT)	; 
	rcall LCD_ANZEIGE_HEX_TEMP1	
	ldi temp1,''
	rcall LCD_ANZEIGE_TEMP1
	ldi temp1,'C'
	rcall LCD_ANZEIGE_TEMP1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Begrungstext																
TEXT_BEGRUESSUNG_1:
.db "1-WIRE-SLAVE ",0
TEXT_BEGRUESSUNG_2:
.db "HYT939 ",0
TEXT_BEGRUESSUNG_3:
.db "ATmega8 4MHz ",0
TEXT_BEGRUESSUNG_4:
.db "01/2016  ",0




